package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TTestdataLayerExample {
    /**
     * t_testdata_layer
     */
    protected String orderByClause;

    /**
     * t_testdata_layer
     */
    protected boolean distinct;

    /**
     * t_testdata_layer
     */
    protected List<Criteria> oredCriteria;

    public TTestdataLayerExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_testdata_layer 2019-03-25
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andLqIdIsNull() {
            addCriterion("lq_id is null");
            return (Criteria) this;
        }

        public Criteria andLqIdIsNotNull() {
            addCriterion("lq_id is not null");
            return (Criteria) this;
        }

        public Criteria andLqIdEqualTo(String value) {
            addCriterion("lq_id =", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdNotEqualTo(String value) {
            addCriterion("lq_id <>", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdGreaterThan(String value) {
            addCriterion("lq_id >", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdGreaterThanOrEqualTo(String value) {
            addCriterion("lq_id >=", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdLessThan(String value) {
            addCriterion("lq_id <", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdLessThanOrEqualTo(String value) {
            addCriterion("lq_id <=", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdLike(String value) {
            addCriterion("lq_id like", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdNotLike(String value) {
            addCriterion("lq_id not like", value, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdIn(List<String> values) {
            addCriterion("lq_id in", values, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdNotIn(List<String> values) {
            addCriterion("lq_id not in", values, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdBetween(String value1, String value2) {
            addCriterion("lq_id between", value1, value2, "lqId");
            return (Criteria) this;
        }

        public Criteria andLqIdNotBetween(String value1, String value2) {
            addCriterion("lq_id not between", value1, value2, "lqId");
            return (Criteria) this;
        }

        public Criteria andLhouseIsNull() {
            addCriterion("lHouse is null");
            return (Criteria) this;
        }

        public Criteria andLhouseIsNotNull() {
            addCriterion("lHouse is not null");
            return (Criteria) this;
        }

        public Criteria andLhouseEqualTo(String value) {
            addCriterion("lHouse =", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseNotEqualTo(String value) {
            addCriterion("lHouse <>", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseGreaterThan(String value) {
            addCriterion("lHouse >", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseGreaterThanOrEqualTo(String value) {
            addCriterion("lHouse >=", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseLessThan(String value) {
            addCriterion("lHouse <", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseLessThanOrEqualTo(String value) {
            addCriterion("lHouse <=", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseLike(String value) {
            addCriterion("lHouse like", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseNotLike(String value) {
            addCriterion("lHouse not like", value, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseIn(List<String> values) {
            addCriterion("lHouse in", values, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseNotIn(List<String> values) {
            addCriterion("lHouse not in", values, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseBetween(String value1, String value2) {
            addCriterion("lHouse between", value1, value2, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLhouseNotBetween(String value1, String value2) {
            addCriterion("lHouse not between", value1, value2, "lhouse");
            return (Criteria) this;
        }

        public Criteria andLtimeIsNull() {
            addCriterion("lTime is null");
            return (Criteria) this;
        }

        public Criteria andLtimeIsNotNull() {
            addCriterion("lTime is not null");
            return (Criteria) this;
        }

        public Criteria andLtimeEqualTo(Date value) {
            addCriterion("lTime =", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeNotEqualTo(Date value) {
            addCriterion("lTime <>", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeGreaterThan(Date value) {
            addCriterion("lTime >", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("lTime >=", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeLessThan(Date value) {
            addCriterion("lTime <", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeLessThanOrEqualTo(Date value) {
            addCriterion("lTime <=", value, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeIn(List<Date> values) {
            addCriterion("lTime in", values, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeNotIn(List<Date> values) {
            addCriterion("lTime not in", values, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeBetween(Date value1, Date value2) {
            addCriterion("lTime between", value1, value2, "ltime");
            return (Criteria) this;
        }

        public Criteria andLtimeNotBetween(Date value1, Date value2) {
            addCriterion("lTime not between", value1, value2, "ltime");
            return (Criteria) this;
        }

        public Criteria andLayernumberIsNull() {
            addCriterion("layerNumber is null");
            return (Criteria) this;
        }

        public Criteria andLayernumberIsNotNull() {
            addCriterion("layerNumber is not null");
            return (Criteria) this;
        }

        public Criteria andLayernumberEqualTo(Integer value) {
            addCriterion("layerNumber =", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberNotEqualTo(Integer value) {
            addCriterion("layerNumber <>", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberGreaterThan(Integer value) {
            addCriterion("layerNumber >", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberGreaterThanOrEqualTo(Integer value) {
            addCriterion("layerNumber >=", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberLessThan(Integer value) {
            addCriterion("layerNumber <", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberLessThanOrEqualTo(Integer value) {
            addCriterion("layerNumber <=", value, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberIn(List<Integer> values) {
            addCriterion("layerNumber in", values, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberNotIn(List<Integer> values) {
            addCriterion("layerNumber not in", values, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberBetween(Integer value1, Integer value2) {
            addCriterion("layerNumber between", value1, value2, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLayernumberNotBetween(Integer value1, Integer value2) {
            addCriterion("layerNumber not between", value1, value2, "layernumber");
            return (Criteria) this;
        }

        public Criteria andLzIsNull() {
            addCriterion("lZ is null");
            return (Criteria) this;
        }

        public Criteria andLzIsNotNull() {
            addCriterion("lZ is not null");
            return (Criteria) this;
        }

        public Criteria andLzEqualTo(String value) {
            addCriterion("lZ =", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzNotEqualTo(String value) {
            addCriterion("lZ <>", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzGreaterThan(String value) {
            addCriterion("lZ >", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzGreaterThanOrEqualTo(String value) {
            addCriterion("lZ >=", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzLessThan(String value) {
            addCriterion("lZ <", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzLessThanOrEqualTo(String value) {
            addCriterion("lZ <=", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzLike(String value) {
            addCriterion("lZ like", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzNotLike(String value) {
            addCriterion("lZ not like", value, "lz");
            return (Criteria) this;
        }

        public Criteria andLzIn(List<String> values) {
            addCriterion("lZ in", values, "lz");
            return (Criteria) this;
        }

        public Criteria andLzNotIn(List<String> values) {
            addCriterion("lZ not in", values, "lz");
            return (Criteria) this;
        }

        public Criteria andLzBetween(String value1, String value2) {
            addCriterion("lZ between", value1, value2, "lz");
            return (Criteria) this;
        }

        public Criteria andLzNotBetween(String value1, String value2) {
            addCriterion("lZ not between", value1, value2, "lz");
            return (Criteria) this;
        }

        public Criteria andLmaxIsNull() {
            addCriterion("lMax is null");
            return (Criteria) this;
        }

        public Criteria andLmaxIsNotNull() {
            addCriterion("lMax is not null");
            return (Criteria) this;
        }

        public Criteria andLmaxEqualTo(BigDecimal value) {
            addCriterion("lMax =", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxNotEqualTo(BigDecimal value) {
            addCriterion("lMax <>", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxGreaterThan(BigDecimal value) {
            addCriterion("lMax >", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lMax >=", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxLessThan(BigDecimal value) {
            addCriterion("lMax <", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lMax <=", value, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxIn(List<BigDecimal> values) {
            addCriterion("lMax in", values, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxNotIn(List<BigDecimal> values) {
            addCriterion("lMax not in", values, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lMax between", value1, value2, "lmax");
            return (Criteria) this;
        }

        public Criteria andLmaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lMax not between", value1, value2, "lmax");
            return (Criteria) this;
        }

        public Criteria andLminIsNull() {
            addCriterion("lMin is null");
            return (Criteria) this;
        }

        public Criteria andLminIsNotNull() {
            addCriterion("lMin is not null");
            return (Criteria) this;
        }

        public Criteria andLminEqualTo(BigDecimal value) {
            addCriterion("lMin =", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminNotEqualTo(BigDecimal value) {
            addCriterion("lMin <>", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminGreaterThan(BigDecimal value) {
            addCriterion("lMin >", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lMin >=", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminLessThan(BigDecimal value) {
            addCriterion("lMin <", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lMin <=", value, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminIn(List<BigDecimal> values) {
            addCriterion("lMin in", values, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminNotIn(List<BigDecimal> values) {
            addCriterion("lMin not in", values, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lMin between", value1, value2, "lmin");
            return (Criteria) this;
        }

        public Criteria andLminNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lMin not between", value1, value2, "lmin");
            return (Criteria) this;
        }

        public Criteria andLavgIsNull() {
            addCriterion("lAvg is null");
            return (Criteria) this;
        }

        public Criteria andLavgIsNotNull() {
            addCriterion("lAvg is not null");
            return (Criteria) this;
        }

        public Criteria andLavgEqualTo(BigDecimal value) {
            addCriterion("lAvg =", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgNotEqualTo(BigDecimal value) {
            addCriterion("lAvg <>", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgGreaterThan(BigDecimal value) {
            addCriterion("lAvg >", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lAvg >=", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgLessThan(BigDecimal value) {
            addCriterion("lAvg <", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lAvg <=", value, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgIn(List<BigDecimal> values) {
            addCriterion("lAvg in", values, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgNotIn(List<BigDecimal> values) {
            addCriterion("lAvg not in", values, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lAvg between", value1, value2, "lavg");
            return (Criteria) this;
        }

        public Criteria andLavgNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lAvg not between", value1, value2, "lavg");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }
    }

    /**
     * t_testdata_layer
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_testdata_layer 2019-03-25
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}